const std = @import("std");
const net = std.net;

pub fn main() !void {
    const address = net.Address.resolveIp("0.0.0.0", 1337) catch {
        @panic("Failed to bind to address.");
    };
    var server = address.listen(net.Address.ListenOptions{}) catch unreachable;
    std.debug.print("Listening to clients.\n", .{});
    defer server.deinit();
    while (true) {
        const conn = server.accept() catch {
            std.debug.print("Connection attempt failed.", .{});
            continue;
        };
        var buf: [32]u8 = undefined;
        while (true) {
            const bytes = try conn.stream.readAll(&buf);
            if (bytes > 0) {
                std.debug.print("Received {d} bytes:\n{s}\n", .{ bytes, buf[0..bytes] });
            }
        }
    }
}

test "simple test" {
    var list = std.ArrayList(i32).init(std.testing.allocator);
    defer list.deinit(); // try commenting this out and see if zig detects the memory leak!
    try list.append(42);
    try std.testing.expectEqual(@as(i32, 42), list.pop());
}
